// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    private cpt_adapt:fgui.GComponent;
    private btn_start:fgui.GButton;
    private cpt_close:fgui.GComponent;
    private view:fgui.GComponent;

    start () {
        fgui.GRoot.create();
        fgui.addLoadHandler();
        fgui.UIPackage.loadPackage("UI/GameTs2", ()=>{
            cc.find("button").on(cc.Node.EventType.TOUCH_END, this.startGame.bind(this));
        })
    }

    private startGame() {
        this.view = fgui.UIPackage.createObject("GameTs2", "TsPanel").asCom;
        fgui.GRoot.inst.addChild(this.view);
        this.cpt_adapt = this.view.getChild("cpt_adapt").asCom;
        this.btn_start = this.view.getChild("btn_start").asButton
        this.cpt_close = this.view.getChild("cpt_close").asCom;
        
        this.btn_start.onClick(this.onBtnStartClick, this);
        this.cpt_close.onClick(this.onCptCloseClick, this);
    }

    private onBtnStartClick() {
        this.cpt_adapt.setSize(900, 800);
    }

    private onCptCloseClick() {
        fgui.GRoot.inst.removeChild(this.view);
    }

    // update (dt) {}
}
